#!/bin/bash

# updated by WIPAT 2555-02-27
# updated by WIBOON 2557-06-23

exitusage()
{
  echo "usage: sudo sh $0 username"
  exit 
}

if [ -z "$(id -nG|grep -w "root")" ] ; then
  echo "need root, or try: sudo sh $0"
  exit
fi
if [ "$1" = "--help" ] ; then
  exitusage
fi
if [ -z "$1" ] ; then
  echo "need username"
  exitusage 
fi

MYUSER=$1
#check apache2 version
if [ -f "/etc/apache2/sites-available/default" ] ; then
  MYFILE="/etc/apache2/sites-available/default"
else
  if [ -f "/etc/apache2/sites-available/000-default.conf" ] ; then
    MYFILE="/etc/apache2/sites-available/000-default.conf"
  else
    echo "No apache2 default site config file"
    exit
  fi
fi
documentroot=$(grep DocumentRoot ${MYFILE} | cut -d' ' -f2)
#
HOME_WWW_RESTRICT="${documentroot}/hidename"
HOME_WWW_PUBLIC="${documentroot}/ishare"
if [ -z "$(getent passwd ${MYUSER})" ] ; then
  echo "username does not exist"
  exit
fi
ID="$(sudo id -u ${MYUSER})"
echo "ID ${ID} is being deleted"
#
if [ -d ${HOME_WWW_RESTRICT}/${ID} ] ; then
  sudo rm ${HOME_WWW_RESTRICT}/${ID}
fi
if [ -d ${HOME_WWW_PUBLIC}/${ID} ] ; then
  sudo rm ${HOME_WWW_PUBLIC}/${ID}
fi
sudo userdel -r ${MYUSER}
echo "${MYUSER} deleted"

