#!/bin/bash

# created by WIBOON 2556-04-18
# updated by WIBOON 2557-06-23

exitusage() 
{
  echo "usage: sudo sh $0 username"
  echo "this is use for upgrade user home from old version installed before"
  echo "2556-04-17 or 2557-06-23"
  exit 
}

if [ -z "$(id -nG|grep -w "root")" ] ; then
  echo "need root, or try: sudo sh $0"
  exit
fi
if [ "$1" = "--help" ] ; then
  exitusage
fi
if [ -z "$1" ] ; then
  echo "need username"
  exitusage 
fi
if [ -z "$(getent passwd $1)" ] ; then
  echo "username does not exist"
  exit
fi

MYUSER=$1
HOME_DIR="/sftp/home"
#check apache2 version
if [ -f "/etc/apache2/sites-available/default" ] ; then
  MYFILE="/etc/apache2/sites-available/default"
else
  if [ -f "/etc/apache2/sites-available/000-default.conf" ] ; then
    MYFILE="/etc/apache2/sites-available/000-default.conf"
  else
    echo "No apache2 default site config file"
    exit
  fi
fi
documentroot=$(grep DocumentRoot ${MYFILE} | cut -d' ' -f2)
#
MYUSER=$1
HOME_DIR="/sftp/home"
HOME_WWW_RESTRICT="${documentroot}/hidename"
HOME_WWW_PUBLIC="${documentroot}/ishare"
README_FILE="DO_NOT_UPLOAD_HERE.txt"
USER_MANUAL="user_manual.txt"
FOLDER_PRIVATE="private"
FOLDER_RESTRICT="hidename"
FOLDER_PUBLIC="ishare"
ID="$(sudo id -u ${MYUSER})"

if [ ! -d "${HOME_WWW_RESTRICT}" ]; then
  sudo mkdir ${HOME_WWW_RESTRICT}
fi
if [ ! -d "${HOME_WWW_PUBLIC}" ]; then
  sudo mkdir ${HOME_WWW_PUBLIC}
fi

echo "(1/2) Setting file and group permission."
sudo mkdir -m 770 ${HOME_DIR}/${MYUSER}/${FOLDER_PRIVATE}
find /sftp/home/${MYUSER} -maxdepth 1 ! -name ".*" ! -name "*private" ! -path "/sftp/home/${MYUSER}" -exec mv {} ${HOME_DIR}/${MYUSER}/${FOLDER_PRIVATE} \;
sudo mkdir -m 771 ${HOME_DIR}/${MYUSER}/${FOLDER_RESTRICT}-${ID}
sudo mkdir -m 775 ${HOME_DIR}/${MYUSER}/${FOLDER_PUBLIC}-${ID}
sudo chmod 555 ${HOME_DIR}/${MYUSER}
sudo chown -R ${MYUSER}:${MYUSER} ${HOME_DIR}/${MYUSER}/*

echo "(2/2) Linking file from home to www directory."
sudo ln -s ${HOME_DIR}/${MYUSER}/${FOLDER_RESTRICT}-${ID} ${HOME_WWW_RESTRICT}/${ID}
sudo ln -s ${HOME_DIR}/${MYUSER}/${FOLDER_PUBLIC}-${ID} ${HOME_WWW_PUBLIC}/${ID}
sudo ln ${HOME_DIR}/${README_FILE} ${HOME_DIR}/${MYUSER}/
sudo ln ${HOME_DIR}/${USER_MANUAL} ${HOME_DIR}/${MYUSER}/

echo ""
echo "User ${MYUSER} home directory was updated successfully."
echo ""

